<?php
/**
 * Performs various database connectivity test prior to install starting.
 * @package Install
 */


require_once('MDB2.php') ;//r die('MDB2 is not installed!');

define(ok,'ok');
$dbOptions= array('persistent'=>true); 
//$dsn = "mssql://sa:Lmtcapdagde@localhost/LMT";
$dsn = "mysql://root:p18704b4@localhost";
$databaseName ='simple_test_db';


function msg($message='') {
  print("<br />");
  print(date('Y/m/d H:i:s').': ' );
  print("$message...");
}
function result($message='',$error=false) {
  
  if (!$error) {
    print("<span style=\"color:green\">$message</span>");
  }
  else {
    print("<span style=\"color:red\">$message</span>");
  }
  //print('<br />');
}

  msg("Attempting to Connect to database using: \"$dsn\"");
  $mdb2 =& MDB2::connect($dsn);
  
  
  if (PEAR::isError($mdb2)) {    
    result($mdb2->getMessage(),true);
    die();
  }
  else  
  {
    result(ok);
  }
  
  msg('Post Connect DSN:'. $mdb2->getDSN());
  msg('Loading "Manager" module');
  $loadManagerResult=$mdb2->loadModule('Manager');
  if (PEAR::isError($loadManagerResult)) {
    result($loadManagerResult->getMessage(),false);
  }
  else {
    result('done');
  }

  $reAttemptCreateDb = false;
  msg('Attempting to create database');
  $r =$mdb2->createDatabase($databaseName);
  if (PEAR::isError($r)) {
    $create1Error= $r->getMessage();
    result($create1Error,true);
    if(strtolower($create1Error)=='mdb2 error: already exists') {
      msg("Database already exists, attempting to drop $databaseName");
      $drop1result=$mdb2->dropDatabase($databaseName);
      if (PEAR::isError($drop1result)) {
	$drop1Error=$drop1result->getMessage();
	result('Unable to drop $databaseName ($drop1Error)',true);
      }
      else {
	result(ok);
	$reAttemptCreateDb=true;
      }
    }
    else {
      result("unexpected error:".$drop1result->getMessage(),false);
    }
  }
  else {
    result(ok);
  }
  
  if ($reAttemptCreateDb) {
    msg('2nd attempt (post-drop) to create database');
    $r =$mdb2->createDatabase($databaseName);
    if (PEAR::isError($r)) {
      $create1Error= $r->getMessage();
      if(strtolower($create1Error)=='mdb2 error: already exists') {
	result($create1Error,true);
      }
      else {
	result("unexpected error: $create1Error",true);
      }
    }
    else {
      result('ok on 2nd attempt',true);
    }
  }
?>